/* This is "cppdefs.h": MODEL CONFIGURATION FILE
   ==== == ============ ===== ============= ====
*/

# define L2SCB
/*
    Embedded (nested) grid configuration segment
*/

c--#ifndef MAX_GRID_LEVEL
c--# define MAX_GRID_LEVEL 2
c--# include "redefs.X"
c--#endif


/*
   Main switch starts here: model configuration choice.
*/

#if defined L2SCB    /* Big Bad Basin Configuration */
c# define DIAGNOSTICS_EDDY
c#define BIO_1ST_USTREAM_TEST
c#define MYMIXING

# define SOLVE3D
# define UV_COR
# define UV_ADV
# define CURVGRID
# define SPHERICAL
# define MASKING
# define MASK_LAND_DATA
# define VERT_COORD_TYPE_SM09

# define EXACT_RESTART
# define AVERAGES
                        ! Equation of State
# define SALINITY
# define NONLIN_EOS
# define SPLIT_EOS


# undef WIND_STRESS_AMP

                       ! Lateral Mixing
# define UV_VIS2
# undef VIS_GRID

# undef ADV_ISONEUTRAL
# define TS_DIF2
# undef DIF_GRID
                       ! Vertical Mixing
# define LMD_MIXING
# define LMD_KPP
# define LMD_BKPP
# define LMD_RIMIX
# define LMD_CONVEC
# define LMD_NONLOCAL
# undef LMD_DDMIX

# define BULK_FLUX

# ifdef BULK_FLUX
#  define DAILYPAR_BEC
c#  define SIMPLE_BULK
#  define COUPLED_SURF_CURR
c#  define COUPLED_SURF_CURR_ONLY_DRAG
c#  define COUPLED_SURF_CURR_ONLY_REL
#  define WND_AT_RHO_POINTS
#  define BULK_DIAGS
#  undef DIURNAL_SRFLUX
#  define SALINITY_RESTORING
# else
#  undef QCORRECTION
#  undef DIURNAL_SRFLUX
#  define STR_AT_RHO_POINTS
# endif
c# define ANA_SMFLUX
c# define ANA_STFLUX
c# define ANA_SSFLUX
c# define ANA_SRFLUX
c# define ANA_INITIAL

                       ! Open Boundary Conditions
# define OBC_WEST
# define OBC_SOUTH
# define OBC_NORTH
c# undef  OBC_EAST
c# define NO_NUDGING_EAST
# define OBC_M2FLATHER
# define OBC_M3ORLANSKI
# define OBC_TORLANSKI

# define Z_FRC_BRY
# define M2_FRC_BRY
# define M3_FRC_BRY 
# define T_FRC_BRY

# define SPONGE

# undef PASSIVE_TRACER
# define BIOLOGY_BEC

# ifdef BIOLOGY_BEC
! this affects parameters for both diaz and phaeo
#  define BEC_LIANG
#  ifdef BEC_LIANG
!# define PHAEOCYSTIS
!# define UMAX35
!# define UMAX51
!# define PCHL25
#  endif

# define SEDIMENT_BIOLOGY

# define BENTHIC_FE_FLUX_SEVERMANN
!# define REDUCED_DIAT_MORT2
!# define QUARTER_DIAT_MORT2
!#define NP16_SP_DIAT
!#define NO_SP_GROWTH
!#define NO_DIAZ_GROWTH

# define OUTPUT_SPECDOM

# ifdef EXPLICIT_SINKING
#  define SEDIMENT_BIOLOGY
# endif
/* this is for the Columbia River, not the outside boundaries */
!#define TCLIM_LOCAL
!#define ANA_TCLIMA
!#define FIXCONC_COLUMBIA

!# define DMS_CYCLE
# define NCYCLE_ANOXIC
!# define NO_PELAGIC_DENIT
!# define ALT_SED_DENIT
!# define N15_CYCLE
# undef BIOLOGY_NPZDOC
# ifdef TCLIMATOLOGY
#  define MULT_CLIM_FILES
# endif
# ifdef DIURNAL_SRFLUX
#  define DAILYPAR_BEC
# endif
# define READ_VARIABLE_ATM_PCO2
!# define VARIABLE_ATM_PCO2

             /* point source */
# define PSOURCE
# define Q_PSOURCE

             /* atm deposition */
c# FLUX_NUTSDEP

# define VFLX_CORR
# define BGC_FLUX_ANALYSIS
# define LARGE_BGC_FILES
# define PHYS_FLUX_ANALYSIS
# define LARGE_PHYS_FILES
# define VERT_DIFF_ANALYSIS
c#define HOR_DIFF_ANALYSIS
c# define PFA_BY_TRACER

c#define OUTPUT_AVG_PHYS_BIO
# endif /* BIOLOGY_BEC */

# define TIDES
# ifdef TIDES
#  define SSH_TIDES
#  define UV_TIDES
#  define TIDERAMP
# endif



# define LARGE_AVG_FILES
# define LARGE_HIS_FILES
# define LARGE_RST_FILES

# endif
 
#include "set_global_definitions.h"
 
! a few checks
#ifdef FULL_PHYS_FLUX_ANALYSIS
# ifdef PFA_BY_TRACER
error this is not yet implemented
# endif
#endif
