#if defined PSOURCE || defined Q_PSOURCE

! Nsrc       Number of point Sources/Sinks.
! Dsrc       Direction of point Sources/Sinks:  0 = along XI-;
!                                          1= along ETA-direction.
! Isrc,Jsrc  i,j-grid location of point Sources/Sinks,
!              0 <= Isrc <= Lm+1;   0 =<- Jsrc <= Mm+1.
! Lsrc       Logical switch indicating which tracer field to apply
!                                         the point Sources/Sinks.
! Qsrc       Mass transport profile (m3/s) of point Sources/Sinks.
! Qbar       Vertically integrated Qsrc (m3/s) of point
! QbarG      Latest two-time snapshots of vertically integrated
!              mass transport (m3/s) of point Sources/Sinks.
! Tsrc       Tracer (tracer units) point Sources/Sinks.
! TsrcG      Latest two-time snapshots of tracer (tracer units)
!              point Sources/Sinks.
! Qshape     Nondimensional shape function to distribute mass
!             ass point Sources/Sinks vertically.

# if defined PSOURCE
      real Qbar(Msrc), Qsrc(Msrc,N),  Qshape(Msrc,N),
     &                                Tsrc(Msrc,N,NT),Tsrc0(Msrc,NT),
     &     Qtemp(Msrc),Qsalt(Msrc),QPO4(Msrc),QNO3(Msrc),
     &     QNH4(Msrc),QFE(Msrc),QO2(Msrc),QDIC(Msrc),QALK(Msrc),
     &     QDOC(Msrc),QDON(Msrc),QDOP(Msrc),QNO2(Msrc),
     &     Qsrctemp(Msrc,N),Qsrcsalt(Msrc,N),QsrcPO4(Msrc,N),QsrcNO3(Msrc,N),
     &     QsrcNH4(Msrc,N),QsrcFE(Msrc,N),QsrcO2(Msrc,N),QsrcDIC(Msrc,N),QsrcALK(Msrc,N),
     &     QsrcDOC(Msrc,N),QsrcDON(Msrc,N),QsrcDOP(Msrc,N),QsrcNO2(Msrc,N)
     &              , QbarG(Msrc,2), TsrcG(Msrc,2,NT), PO4G(Msrc,2),
     &              tempG(Msrc,2),saltG(Msrc,2),
     &              NO3G(Msrc,2),NH4G(Msrc,2),FEG(Msrc,2),O2G(Msrc,2),
     &              DICG(Msrc,2),ALKG(Msrc,2),DOCG(Msrc,2),DONG(Msrc,2),
     &              DOPG(Msrc,2),NO2G(Msrc,2),
     &              psrc_Hz(60), psrc_pm(1),psrc_pn(1)
      real QpsrcPO4_3D(GLOBAL_2D_ARRAY,N),  QpsrcNO3_3D(GLOBAL_2D_ARRAY,N),
     &    QpsrcNH4_3D(GLOBAL_2D_ARRAY,N),  QpsrcFE_3D(GLOBAL_2D_ARRAY,N),
     &    QpsrcO2_3D(GLOBAL_2D_ARRAY,N),  QpsrcDIC_3D(GLOBAL_2D_ARRAY,N),
     &    QpsrcALK_3D(GLOBAL_2D_ARRAY,N),  QpsrcDOC_3D(GLOBAL_2D_ARRAY,N),
     &    QpsrcDON_3D(GLOBAL_2D_ARRAY,N),  QpsrcDOP_3D(GLOBAL_2D_ARRAY,N),
     &    QpsrcNO2_3D(GLOBAL_2D_ARRAY,N),
     &    cffa(GLOBAL_2D_ARRAY),Vz(GLOBAL_2D_ARRAY,N)


      real psrc_time(2), psrc_cycle, var1d(Msrc)
      integer itpsrc, psrc_ncycle, psrc_rec, psrc_tid,
     &        QbarG_id, TsrcG_id(NT), ncidfpsrc, ntpsrc, 
     &        tempG_id,saltG_id,
     &        PO4G_id,NO3G_id,NH4G_id,FEG_id,O2G_id,
     &        DICG_id,ALKG_id,DOCG_id,DONG_id,DOPG_id,NO2G_id
      common /source_psrcdat/ psrc_time, psrc_cycle,
     &        itpsrc, psrc_ncycle, psrc_rec, psrc_tid,
     &        QbarG_id, TsrcG_id, ncidfpsrc, ntpsrc,
     &        tempG_id,saltG_id,PO4G_id,NO3G_id,NH4G_id,
     &        FEG_id,O2G_id,DICG_id,ALKG_id,DOCG_id,DONG_id,
     &        DOPG_id,NO2G_id

      integer Nsrc, Dsrc(Msrc), Isrc(Msrc), Jsrc(Msrc)
      logical Lsrc(Msrc,NT)
      common /sources_all/ Qbar, Qsrc, Qshape, Tsrc,
     &     Qtemp,Qsalt,QPO4,QNO3,
     &     QNH4,QFE,QO2,QDIC,QALK,
     &     QDOC,QDON,QDOP,QNO2,
     &     Qsrctemp,Qsrcsalt,QsrcPO4,QsrcNO3,
     &     QsrcNH4,QsrcFE,QsrcO2,QsrcDIC,QsrcALK,
     &     QsrcDOC,QsrcDON,QsrcDOP,QsrcNO2,
 # endif
# ifndef PSOURCE
     &                          QbarG, TsrcG, Tsrc0,
     &                          saltG,tempG,
     &                          PO4G,NO3G,NH4G,FEG,O2G,
     &                          DICG,ALKG,DOCG,DONG,DOPG,NO2G,
# endif
     &                 Nsrc, Dsrc, Isrc, Jsrc, Lsrc
#endif


!# ifndef ANA_PSOURCE
!     &             , QbarG(Msrc,2) !, TsrcG(Msrc,N,2,NT)
!# endif
!      integer Nsrc, Dsrc(Msrc), Isrc(Msrc), Jsrc(Msrc)
!
!      common /sources_all/ Qbar, Qsrc, Qshape, Tsrc,
!# ifndef ANA_PSOURCE
!     &                                  QbarG, TsrcG,
!# endif
!     &                       Nsrc, Dsrc, Isrc, Jsrc
!#endif
